;;;  Parallel sorting with multiple keys -- technique suggested by E.S. Yu

(*DEFVAR K1 (random!! (!! 8)))
(*DEFVAR K2 (random!! (!! 16)))
(*DEFVAR K3 (random!! (!! 32)))

(*DEFVAR R  (!! 0))
(*DEFVAR R1 (!! 0))
(*DEFVAR R2 (!! 0))

(*DEFVAR Q1 (!! 0))
(*DEFVAR Q2 (!! 0))

(*DEFVAR S (!! 0))

(defvar CSZ *number-of-processors-limit*)

(setq *print-array* t)

;;; Sort according to k1, k2, k3

(*defun sort3 (k1 k2 k3)
  (*set R1 (rank!! k3 '<=!!))
  (*set Q1 (+!! (*!! (!! CSZ) k2) R1))
  (*set R2 (rank!! Q1 '<=!!))
  (*set Q2 (+!! (*!! (!! CSZ) k1) R2))
  (*set R (rank!! Q2 '<=!!))
  ;;; Display results
  (format t " k1   k2   k3   R1   Q1   R2   Q2   R~%")
  (dotimes (i CSZ)
   (format t "~4D ~4D ~4D ~4D ~4D ~4D ~4D ~4D~%"
     (pref k1 i) (pref k2 i) (pref k3 i) (pref R1 i)
     (pref Q1 i) (pref R2 i) (pref Q2 i) (pref R i)))
)
